import { AfterViewInit, Component, OnInit, ViewChild } from '@angular/core';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';

const DATA_EXAMPLE: Array<any> = [
  {
    NUMERO_PEDIDO: '0000000001',
    FECHA_ENTREGA: '2023-01-19 12:20:53',
    USUARIO_REGISTRA: 'Jean Jairo Benitez Meza',
    PORCENTAJE: '50',
  },
  {
    NUMERO_PEDIDO: '0000000002',
    FECHA_ENTREGA: '2023-01-19 12:20:53',
    USUARIO_REGISTRA: 'Jean Jairo Benitez Meza',
    PORCENTAJE: '20',
  },
  {
    NUMERO_PEDIDO: '0000000003',
    FECHA_ENTREGA: '2023-01-19 12:20:53',
    USUARIO_REGISTRA: 'Jean Jairo Benitez Meza',
    PORCENTAJE: '33',
  },
  {
    NUMERO_PEDIDO: '0000000004',
    FECHA_ENTREGA: '2023-01-19 12:20:53',
    USUARIO_REGISTRA: 'Jean Jairo Benitez Meza',
    PORCENTAJE: '80',
  },
];

@Component({
  selector: 'app-partial-deliveries',
  templateUrl: './partial-deliveries.component.html',
  styleUrls: ['./partial-deliveries.component.css']
})
export class PartialDeliveriesComponent implements AfterViewInit, OnInit {

  public displayedColumns: Array<string>;
  public dataSource: MatTableDataSource<any>;
  @ViewChild(MatPaginator) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;
  public txtBuscador:string;

  public isLoading: boolean;
  public isLoadingForm: boolean;
  public btnSmall: boolean;

  constructor() {
    this.displayedColumns = [ 'NUMERO_PEDIDO', 'FECHA_ENTREGA', 'USUARIO_REGISTRA', 'PORCENTAJE', 'ACCIONES' ];
    this.dataSource = new MatTableDataSource(DATA_EXAMPLE);
    this.isLoading = false;
    this.isLoadingForm = false;
    this.btnSmall = false;
    this.txtBuscador = '';
  }

  ngOnInit(): void {
    this.onResize();
  }

  ngAfterViewInit(): void {
    this.dataSource.paginator = this.paginator;
    this.dataSource.sort = this.sort;
  }

  // Método de filtrado de datos
  public applyFilter(event: any, type: string):void {
    let filterValue:string;
    if (type == 'INP') {
      filterValue = (event.target as HTMLInputElement).value;
    }else{
      this.txtBuscador = event;
      filterValue = event;
    }
    this.dataSource.filter = filterValue.trim().toLowerCase();
    if (this.dataSource.paginator) {
      this.dataSource.paginator.firstPage();
    }
  }

  // Método para reajustar los botones según sus dimensiones
  public onResize():void {
    this.btnSmall = window.innerWidth <= 1405;
  }

  // Método para dar formato a las fechas y horas
  public formatDate(dateRegister:string, dateUpdate:string | null):string {
    let date:string = (dateUpdate === null) ? dateRegister : dateUpdate;
    let arrDateTime:Array<string> = date.split(' ');
    let arrDate:Array<string> = arrDateTime[0].split('-');
    return `${arrDate[2]}-${arrDate[1]}-${arrDate[0]} ${arrDateTime[1]}`;
  }
}
